define class Tables as MetaDataCollection
	lFillOnInit = .T.

	procedure FillCollection
		local lcTable, ;
			loTable, ;
			lcField, ;
			loField, ;
			lcIndex, ;
			loIndex
		use CoreMeta
		scan
			do case

* If this is a table or view, add it to the collection.

				case cRecType $ 'TV'
					lcTable = trim(cObjectNam)
					loTable = createobject('Table')
					with loTable
						.CodePage  = nCodePage
						.BlockSize = nBlockSize
						.Caption   = trim(cCaption)
					endwith
					This.Add(loTable, lcTable)

* If this is a field, add it to the appropriate table.

				case cRecType = 'F'
					lcTable = juststem(cObjectNam)
					lcField = trim(justext(cObjectNam))
					loField = createobject('Field')
					with loField
						.DataType   = cType
						.Length     = nSize
						.Decimals   = nDecimals
						.Binary     = lBinary
						.AllowNulls = lNull
						.Caption    = trim(cCaption)
					endwith
					This.Item(lcTable).Fields.Add(loField, lcField)

* If this is an index, add it to the appropriate table.

				case cRecType = 'I'
					lcTable = juststem(cObjectNam)
					lcIndex = trim(justext(cObjectNam))
					loIndex = createobject('Index')
					with loIndex
						.Expression = mTagExpr
						.Filter     = mTagFilter
						.Type       = cTagType
						.Ascending  = lAscending
						.Collate    = trim(cCollate)
						.Caption    = trim(cCaption)
					endwith
					This.Item(lcTable).Indexes.Add(loIndex, lcIndex)
			endcase
		endscan
		use
	endproc
enddefine

define class MetaDataCollection as SFCollection of SFCtrls.vcx
	protected function FillArrayRow(taArray, tnItem, toItem)
		dimension taArray[tnItem, 2]
		taArray[tnItem, 1] = toItem.Caption
		taArray[tnItem, 2] = This.GetKey(tnItem)
	endfunc
enddefine

define class Table as Custom
	CodePage  = 0
	BlockSize = 0
	Caption   = ''
	
	add object Fields  as MetaDataCollection
	add object Indexes as MetaDataCollection
enddefine

define class Field as Custom
	DataType   = ''
	Length     = 0
	Decimals   = 0
	Binary     = .F.
	AllowNulls = .F.
	Caption    = ''
enddefine

define class Index as Custom
	Expression = ''
	Filter     = ''
	Type       = ''
	Ascending  = .F.
	Collate    = ''
	Caption    = ''
enddefine
